open import general-notation

data ℕ : Type where
  zero : ℕ
  suc : ℕ → ℕ
  
{-# BUILTIN NATURAL ℕ #-}

-- Doubt: Type formers are same as constructors?
ℕ-elim :
  {A : ℕ → Type}
  → A 0
  → ((k : ℕ) → A k → A (suc k))
  → (n : ℕ) → A n
ℕ-elim {A} a₀ f = h
 where
  h : (n : ℕ) → A n
  h zero = a₀
  h (suc n) = f n (h n)
  

-- TODO: ℕ-nondep-elim

_+_ : ℕ → ℕ → ℕ
x + zero = x
x + suc y = suc (x + y)

_*_ : ℕ → ℕ → ℕ
x * zero = zero
x * suc y = y + (x * y)

infixr 20 _+_
infixr 30 _*_
