open import general-notation

data Σ0 {A : Type} (B : A → Type) : Type where
  _,_ : (x : A) (y : B x) → Σ0 {A} B
  
pr₁0 : {A : Type} {B : A → Type} (z : Σ0 B) → A
pr₁0 (x , y) = x
  
pr₂0 : {A : Type} {B : A → Type} (z : Σ0 B) → B (pr₁0 z)
pr₂0 (x , y) = y

record Σ {A : Type} (B : A → Type) : Type where
 constructor
  _,_ 
 field
  pr₁ : A
  pr₂ : B pr₁
  
open Σ public
-- public to make even the module importing this would have Σ

infix 0 _,_
-- default is right associative
--   (a, (b, c)) is same as (a, b, c)

Sigma : (A : Type) (B : A → Type) → Type
Sigma A B = Σ {A} B

syntax Sigma A (λ x → b) = Σ x ꞉ A , b

