package rca;

// Full adder
function Bit#(2) fa (Bit#(1) a, Bit#(1) b, Bit#(1) cin);
  /* Bit#(1) s = a ^ b ^ cin; */
  /* Bit#(1) cout = (a & b) | (b & cin) | (a & cin); */

  let s = a ^ b ^ cin;
  let cout = (a & b) | (b & cin) | (a & cin);

  return {cout, s};
endfunction

// Full adder
function Bit#(TAdd#(w, 1)) rca (Bit#(w) a, Bit#(w) b, Bit#(1) cin);
  // Carry bits
  Bit#(TAdd#(w, 1)) cs = 0;
  cs[0] = cin;

  // Sum bits
  Bit#(w) s;

  let wval = valueOf(w);

  for (Integer i=0; i<wval; i=i+1) begin
    let res = fa(a[i], b[i], cs[i]);
    s[i] = res[0];
    cs[i+1] = res[1];
  end

  return {cs[wval], s};
endfunction

endpackage
