{-
Tolerating monitor

Examine if sum of values in two input streams exceed a limit.
If limit is exceeded, see if it comes back to confirmance with a fixed
number of cycles and if it doesn't give False. Else keep giving True.
-}

import Clash.Prelude
import Clash.Explicit.Testbench

-- data NoNF = Unl Int NoNF
-- λ> a = Unl 3  a

data State =
   Good
 | Bad
 | Tolerating Int
 deriving (Generic, NFDataX, Show)  -- ADDED

monTf :: Int -> ((,) Int Int) -> State -> ((,) Int Int) -> (,) State Bool
monTf limit bounds st ab =
  let {a = fst ab} in
  let {b = snd ab} in
  let {low = fst bounds} in
  let {high = snd bounds} in
  let {res = (+) a b} in
  let {outsideLimits = (||) ((<) res low) ((>) res high)} in
  case st of {
   Good ->
    case outsideLimits of {
     True -> (,) (Tolerating (succ 0)) True;
     False -> (,) Good True};
   Bad -> (,) Bad False;
   Tolerating failCount ->
    case outsideLimits of {
     True ->
      case (==) failCount limit of {
       True -> (,) Bad False;
       False -> (,) (Tolerating (succ failCount)) True};
     False -> (,) Good True}}



mon
  :: SystemClockResetEnable
  => Signal System (Int, Int)
  -> Signal System Bool
mon = mealy tf Good
 where
  tf = monTf 2 (10, 20)

topEntity
  :: Clock System
  -> Reset System
  -> Enable System
  -> Signal System (Int, Int)
  -> Signal System Bool
topEntity = exposeClockResetEnable mon







-- -- | Monitor state
-- data State
--   = Good            -- ^ No intolerable violation
--   | Bad             -- ^ Violation beyond tolerance
--   | Tolerating Word -- ^ Tolerating violation
--   deriving (Generic, NFDataX, Show)

-- monTf
--   :: (Num a, Ord a)
--   => Word            -- ^ Tolerance limit (inclusive)
--   -> (a, a)          -- ^ Lowest and highest allowed sum
--   -> State           -- ^ Current state
--   -> (a, a)          -- ^ Input values
--   -> (State, Bool)   -- ^ Next state and output
-- monTf limit (low, high) s (a, b) = case s of
--   Good ->
--     if outsideLimits res then
--       (Tolerating 1, True)
--     else
--       (Good, True)
--   Bad -> (Bad, False)
--   Tolerating failCount ->  
--     if outsideLimits res then
--       --if failCount > limit then  -- Spec mismatch. Tolerance is inclusive
--       if failCount == limit then
--         (Bad, False)
--       else
--         (Tolerating (failCount+1), True)
--     else
--       (Good, True)
--  where
--   res = a + b
--   outsideLimits val = val < low || val > high

-- mon
--   :: SystemClockResetEnable
--   => Signal System (Signed 8, Signed 8)
--   -> Signal System Bool
-- mon = mealy tf Good
--  where
--   tf = monTf 2 (10, 20)

-- topEntity
--   :: Clock System
--   -> Reset System
--   -> Enable System
--   -> Signal System (Signed 8, Signed 8)
--   -> Signal System Bool
-- topEntity = exposeClockResetEnable mon


-- testBench :: Signal System Bool
-- testBench = done
--   where
--     testInput      = stimuliGenerator clk rst
--       $(listToVecTH [(10, 15) :: (Signed 8, Signed 8),
--                      (25, 12),
--                      (23, 30),
--                      (1, 4)])
--     expectedOutput = outputVerifier' clk rst
--       $(listToVecTH [True,
--                      True,
--                      False,
--                      False])
--     done           = expectedOutput (topEntity clk rst (enableGen) testInput)
--     clk            = tbSystemClockGen (not <$> done)
--     rst            = systemResetGen

-- {- 
-- λ> monTf 2 (10,20) (Good) (10,15)
-- (Tolerating 1,True)

-- λ> monTf 2 (10,20) (Tolerating 1) (25,12)
-- (Tolerating 2,True)

-- λ> monTf 2 (10,20) (Tolerating 2) (23,30)
-- (Bad,False)


-- -----------------------

-- λ> monTf 2 (5,10) (Good) (0,1)
-- (Tolerating 1,True)

-- λ> monTf 2 (5,10) (Tolerating 2) (0,1)
-- (Bad,False)

-- λ> monTf 2 (5,10) (Tolerating 1) (0,1)
-- (Tolerating 2,True)

-- λ> monTf 2 (5,10) (Bad) (0,1)
-- (Bad,False)
-- -}

-- {-
-- λ> import qualified Data.List
-- λ> Data.List.take 5 $ sample testBench
-- [False,False,False,False,False]
-- -}

-- --Data.List.take 5 $ sample $ exposeClockResetEnable mon




-- -- [nix-shell:~/gits/playground/clash]$ clash --vhdl MonWithTolerance.hs
-- -- GHC: Setting up GHC took: 0.697s
-- -- GHC: Compiling and loading modules took: 3.549s
-- -- Clash: Parsing and compiling primitives took 0.195s
-- -- GHC+Clash: Loading modules cumulatively took 4.757s
-- -- Clash: Compiling Main.testBench
-- -- Clash: Compiling Main.topEntity
-- -- Clash: Normalization took 0.090s
-- -- Clash: Netlist generation took 0.000s
-- -- Clash: Normalization took 0.117s
-- -- Clash: Netlist generation took 0.002s
-- -- Clash: Compiling Main.topEntity took 0.163s
-- -- Clash: Compiling Main.testBench took 0.183s
-- -- Clash: Total compilation took 4.943s
 
