(* From mathcomp Require Import ssralg. *)
(* From mathcomp.algebra Require Import matrix. *)
From mathcomp Require Import all_ssreflect all_algebra.

(* https://github.com/coq-community/coqeal/tree/1.1.3 *)


Local Open Scope ring_scope.

Definition egmat: 'M[bool]_3 := \matrix_(i<3, j<3) (true).


From CoqEAL Require Import hrel param refinements trivial_seq.
From CoqEAL.refinements Require Import seqmx.

Check fun_of_matrix egmat.
Check mkseqmx_ord.
(*
mkseqmx_ord
     : forall (A : Type) (m n : nat), ('I_m -> 'I_n -> A) -> seqmx
*)
Definition egseq := mkseqmx_ord (fun_of_matrix egmat).
Print egseq.

Require Import Extraction.
Extraction Language Haskell.         
Require Import ExtrHaskellBasic.     
Require Import ExtrHaskellZInteger.
Require Import ExtrHaskellNatNum.
Require Import ExtrHaskellString.

Recursive Extraction eqseq.
Definition eglst: list bool := cons true (cons false (cons true nil)).
Recursive Extraction eglst.
(*
eglst :: ([]) Prelude.Bool
eglst =
  (:) Prelude.True ((:) Prelude.False ((:) Prelude.True ([]))) *)

Check (0 : 'M[int]_(2,2)).

Goal ((0 : 'M[int]_(2,2)) == (const_mx 0)).
  (* by coqeal (1* didn't work *1) *)
  rewrite /const_mx //.
Qed.

Search mkseqmx_ord.
Check nat_Rxx.
Print nat_R.
Check refines.
Check refine_mkseqmx_ord id 3 3.
Check Refinements.Op.zero_of bool.
Print Refinements.Op.zero_of.

Goal ((0 : 'M[int]_(2,2)) == 0).
  by rewrite /const_mx.
Qed.

Goal (Mp *m 0 == 0 :> 'M[_]_(2,2)).
Locate "*m".
  Check mulmx.
  rewrite /mulmx //.
  vm_compute.
  by coqeal.
Abort.

(* [coqeal] tactic is defined as:

```
Ltac coqeal := apply: refines_goal; vm_compute.
```
 *)
