open Cmdliner

(*
let cmd =
  let doc = "An observability tool for OCaml programs" in
*)


(*
let gc_stats_cmd =
  let man =
    [
      `S Manpage.s_description;
      `P "Report the GC latency profile.";
      `Blocks help_secs;
    ]
  in
*)

(*
  let doc = "Report the GC latency profile and stats." in
  let man = [
    `S Manpage.s_description;
  ] in
  let info = Cmd.info "gc-stats" ~doc ~sdocs ~man in
  Cmd.v info Term.(const gc_stats $ json_option $ output_option $ exec_args 0)
in
*)

(* let revolt () = print_endline "Revolt!" *)
(* let revolt_t = Term.(const revolt $ const ()) *)

(* let cmd = Cmd.v (Cmd.info "revol") revolt_t *)

(* let main () = exit (Cmd.eval cmd) *)
(* let () = main () *)

let revolt () = print_endline "Revolt!"
let revolt_t = Term.(const revolt $ const ())

let cmd =
  let doc = "main docstring" in
  let man = [
    `S Manpage.s_bugs;
    `P "bug section descr";
    `I ("Wall time", "Real execution time of the program");
    `I ("CPU time", "Total CPU time across all domains");
    `I ("GC time", "Total time spent by the program performing garbage collection (major and minor)");
    `I ("GC overhead", "Percentage of time taken up by GC against the total execution time");
    `I ("GC time per domain", "Time spent by every domain performing garbage collection (major and minor cycles). Domains are reported with their domain ID (e.g. `Domain0`)");
    `I ("GC latency profile", "Mean, standard deviation and percentile latency profile of GC events.")] in
  let info = Cmd.info "cmdname-info" ~version:"0.0.1" ~doc ~man in
  Cmd.v info revolt_t

let main () = exit (Cmd.eval cmd)
let () = main ()
