(*
fun qsort [] = []
  | qsort (pivot::ls) = 
    let val (less, more) = List.partition (fn x => x < pivot) ls in
    (qsort less) @ [pivot] @ (qsort more)
    end
*)

signature SORT =
sig
  type t
  val sort : t list -> t list
end

functor QSort (O: ORD_KEY ): SORT =
struct
  type t = O.ord_key
  fun sort [] = []
    | sort (pivot::ls) = 
        let
      fun cmpfn LESS = true
        | cmpfn EQUAL = true
        | cmpfn _ = false
      val (less, more) = List.partition (fn x => (cmpfn o O.compare)(x,pivot)) ls
    in
          (sort less) @ [pivot] @ (sort more)
        end
end
  
structure IntOrd : ORD_KEY =
struct
  type ord_key = int

  (* Same as Int.compare *)
  fun compare (a,b) =
    if a < b then LESS
    else if a > b then GREATER
    else EQUAL
end
  
structure IntQSort = QSort(IntOrd)

(*
fun o2b x = if (x = LESS orelse x = EQUAL) then true else false;
val o2b = fn : order -> bool
- val ctr = ref 0;
val ctr = ref 0 : int ref
- (o2b o Int.compare)(2,3);
val it = true : bool
- (o2b o Int.compare)(3,3);
val it = true : bool
- (o2b o Int.compare)(4,3);
val it = false : bool
*)
