---------------
-- DESIGN
---------------
---------------

---------------
-- AND
---------------

library ieee;
use ieee.std_logic_1164.all;

entity andop is
  port(
    a, b    : in  std_logic;
    and_out : out std_logic
  );
end entity andop;

architecture behavioral of andop  is
begin
  and_out <= a and b;
end architecture;


---------------
-- XOR
---------------

library ieee;
use ieee.std_logic_1164.all;

entity xorop is
  port(
    a, b : in  std_logic;
    xor_out : out std_logic
  );
end entity xorop;

architecture behavioral of xorop is
begin
  xor_out <= a xor b;
end architecture;


---------------
-- ALU
---------------

library ieee;
use ieee.std_logic_1164.all;

entity alu is
  port(
    a, b : in  std_logic;
    sel  : in  std_logic;
    o    : out std_logic
  );
end entity alu;

architecture behavioral of alu is
  signal xor_out : std_logic;
  signal and_out : std_logic;
begin
  xorcomp : entity work.xorop port map(
    a, b, xor_out 
  );
  andcomp : entity work.andop port map(
    a, b, and_out
  );

  with sel select o <=
    and_out when '0',
    xor_out when others;
end architecture;
