library ieee;
use ieee.std_logic_1164.all;

package toppack is
  type rec_type is record 
    vec : std_logic_vector(1 downto 0);
    bt  : std_logic;
  end record;
end toppack;

-----

library ieee;
use ieee.std_logic_1164.all;
use work.toppack.all;

entity recinps is
  port(
    a: in  rec_type;
    q: out std_logic
  );
end recinps;

architecture behavioral of recinps is
begin
  process
    constant all1s : std_logic_vector(1 downto 0) := "11";
    variable temp : std_logic_vector(1 downto 0);
  begin
    temp := a.vec xor all1s;
    if temp = all1s then
      q <= '1' xor a.bt;
    else
      q <= '0' xor a.bt;
    end if;
  end process;
end architecture behavioral;
